"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.help = help;
exports.usage = usage;
exports.messages = exports.Message = exports.config = exports.commands = void 0;

var _assign = _interopRequireDefault(require("@babel/runtime/core-js/object/assign"));

var _values = _interopRequireDefault(require("@babel/runtime/core-js/object/values"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _toArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _yargsParser = _interopRequireDefault(require("yargs-parser"));

var _menhera = require("menhera");

var _chalk = _interopRequireDefault(require("chalk"));

var _utils = require("./utils");

var commands = {
  $: function $(_ref) {
    var _this = this;

    var _key = _ref._key,
        _val = _ref._val,
        cp = _ref.cp;
    var rootAlias = this.config.rootAlias;
    var name = _val.name,
        _val$args = _val.args,
        args = _val$args === void 0 ? [] : _val$args,
        _val$desc = _val.desc,
        cDesc = _val$desc === void 0 ? "" : _val$desc,
        _val$options = _val.options,
        options = _val$options === void 0 ? {} : _val$options;
    var key = name || _key;
    this.commands[key] = _val;
    var commandOutput = [];
    args = args.map(function (argv) {
      return "[".concat(argv, "]");
    });

    if (key !== rootAlias) {
      commandOutput.push("".concat((0, _utils.genOutput)({
        input: "".concat(key),
        chalkFn: _chalk.default.magenta,
        length: 8,
        left: 2
      })).concat((0, _utils.genOutput)({
        input: "".concat(args.join(" ")),
        chalkFn: _chalk.default.grey,
        length: 40
      })).concat((0, _utils.genOutput)({
        input: "".concat(cDesc),
        chalkFn: _chalk.default.grey,
        length: 10
      }), "\n"));
    }

    var optionOutput = [];
    (0, _menhera.$)(options, function (option, val) {
      var alias = val.alias,
          oDesc = val.desc;
      _this.alias[option] = alias;
      _this.alias[alias] = option;
      optionOutput.push("".concat((0, _utils.genOutput)({
        input: "-".concat(alias),
        chalkFn: _chalk.default.grey,
        length: 5,
        left: 10
      })).concat((0, _utils.genOutput)({
        input: "--".concat(option),
        chalkFn: _chalk.default.grey,
        length: 35
      })).concat((0, _utils.genOutput)({
        input: oDesc,
        chalkFn: _chalk.default.grey,
        length: 10
      }), "\n"));
    });
    (0, _menhera.$set)(this.helper, (0, _defineProperty2.default)({}, key, {
      optionOutput: optionOutput,
      commandOutput: commandOutput
    }));
  }
};
exports.commands = commands;
var config = {
  _: function _(_ref2) {
    var _2 = _ref2._,
        _val = _ref2._val;
    (0, _menhera.$set)(this.config, _val);
  },
  start: function start(_ref3) {
    var _this2 = this;

    var _ = _ref3._,
        _val = _ref3._val;
    var _this$config = this.config,
        target = _this$config.target,
        rootAlias = _this$config.rootAlias;

    var _parser = (0, _yargsParser.default)(target || process.argv.slice(2)),
        __ = _parser._,
        options = (0, _objectWithoutProperties2.default)(_parser, ["_"]);

    var _3 = (0, _toArray2.default)(__),
        _$2 = _3[0],
        _key = _$2 === void 0 ? rootAlias : _$2,
        args = _3.slice(1);

    (0, _menhera.$)(options, function (key, val) {
      _this2.args[key] = val;
      var alias = _this2.alias[key];

      if (alias) {
        _this2.args[alias] = val;
      }
    });
    var command = this.commands[_key] || {};

    var _command$args = command.args,
        _args = _command$args === void 0 ? [] : _command$args;

    _args.forEach(function (argv, i) {
      _this2.args[argv] = args[i];
    });

    args.forEach(function (argv, i) {
      _this2.args["$".concat(i)] = args[i];
    });
    var out = (0, _objectSpread2.default)({
      _: _
    }, this, this.args, {
      _key: _key,
      options: options,
      args: args
    });
    var val = (0, _objectSpread2.default)({}, out, {
      env: (0, _utils.ENV)((0, _objectSpread2.default)({}, out, {
        _args: _args
      }))
    });
    var _command$exec = command.exec,
        exec = _command$exec === void 0 ? function () {} : _command$exec;
    var help = val.help,
        v = val.v;

    if (help) {
      _.$use({
        CLI: {
          help: _key
        }
      });

      return;
    }

    if (v) {
      var version = this.config.version;
      console.log(version);
      return;
    }

    exec(val);
  }
};
exports.config = config;

function help(_ref4) {
  var _val = _ref4._val;
  var help;
  var rootAlias = this.config.rootAlias;

  if (_val !== rootAlias || !_val) {
    help = this.helper[_val];
  } else {
    help = {
      commandOutput: (0, _values.default)(this.helper).map(function (help) {
        return help.commandOutput;
      }),
      optionOutput: this.helper[rootAlias].optionOutput
    };
  }

  console.log("\n\n".concat(_chalk.default.grey("Commands:"), "\n\n").concat(help.commandOutput.join(""), "\n\n").concat(_chalk.default.grey("Options:"), "\n\n").concat(help.optionOutput.join(""), "\n    "));
}

function usage(_ref5) {
  var _val = _ref5._val;
  var help = this.helper[_val];
  help && console.log(" \n  \n".concat(_chalk.default.grey("Usage:"), "\n              \n    ").concat(help.commandOutput.join("")));
}

var Message = {
  $: function $(_ref6) {
    var _key = _ref6._key,
        _val = _ref6._val;
    var messages = this.messages[_key] || {};
    var message = messages[_val] || "";

    if (message) {
      typeof message === "function" && console.log(message(this));
      typeof message !== "function" && console.log(message);
    } else {
      console.log("can not find message with key: ".concat(_key, " val: ").concat(_val));
    }
  }
};
exports.Message = Message;
var messages = {
  _: function _(_ref7) {
    var _val = _ref7._val;
    (0, _assign.default)(this.messages, _val);
  }
};
exports.messages = messages;