"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ENV = exports.genOutput = exports.fillSpace = exports.space = void 0;

var _keys = _interopRequireDefault(require("@babel/runtime/core-js/object/keys"));

var _from = _interopRequireDefault(require("@babel/runtime/core-js/array/from"));

var space = function space(num) {
  return (0, _from.default)(new Array(num)).join(" ");
};

exports.space = space;

var fillSpace = function fillSpace(size, current) {
  return space(size - current);
};

exports.fillSpace = fillSpace;

var genOutput = function genOutput(_ref) {
  var input = _ref.input,
      chalkFn = _ref.chalkFn,
      length = _ref.length,
      _ref$left = _ref.left,
      left = _ref$left === void 0 ? 0 : _ref$left,
      _ref$right = _ref.right,
      right = _ref$right === void 0 ? 0 : _ref$right;
  var inputLenght = input.length;
  var output = chalkFn(input);
  (!length || inputLenght > length) && (length = inputLenght);
  return "".concat(space(left)).concat(output || []).concat(fillSpace(length, inputLenght)).concat(space(right));
};

exports.genOutput = genOutput;

var ENV = function ENV(_ref2) {
  var $0 = _ref2.$0,
      _args = _ref2._args,
      args = _ref2.args,
      options = _ref2.options;
  var env = {};
  env.NONE_ARGS = args.length === 0;
  env.NONE_OPTIONS = (0, _keys.default)(options).length === 0;
  env.NONE_INPUTS = env.NONE_ARGS && env.NONE_OPTIONS;
  env.NONE_FULL_ARGS = _args.length !== args.length;
  return env;
};

exports.ENV = ENV;